﻿SLASH_ATA1 = '/ata';
local function AtaCommand(msg, editbox)
	listeHF = 0;
	-- Wrath of the Lich King
	if msg == 'onyxia10' then listeHF = HFList("onyxia10"); end
	if msg == 'onyxia25' then listeHF = HFList("onyxia25"); end
	if msg == 'archavon10' then listeHF = HFList("archavon10"); end
	if msg == 'archavon25' then listeHF = HFList("archavon25"); end
	if msg == 'malygos10' then listeHF = HFList("malygos10"); end
	if msg == 'malygos25' then listeHF = HFList("malygos25"); end
	if msg == 'sartha10' then listeHF = HFList("sartha10"); end
	if msg == 'sartha25' then listeHF = HFList("sartha25"); end
	if msg == 'naxx10' then listeHF = HFList("naxx10"); end
	if msg == 'naxx25' then listeHF = HFList("naxx25"); end
	if msg == 'ulduar10' then listeHF = HFList("ulduar10"); end
	if msg == 'ulduar25' then listeHF = HFList("ulduar25"); end
	if msg == 'coliseum10' then listeHF = HFList("coliseum10"); end
	if msg == 'coliseum25' then listeHF = HFList("coliseum25"); end
	if msg == 'icc10' then listeHF = HFList("icc10"); end
	if msg == 'icc25' then listeHF = HFList("icc25"); end
	-- Cataclysm
	if msg == 'bwd' then listeHF = HFList("bwd"); end
	if msg == 'bot' then listeHF = HFList("bot"); end
	if msg == 'tfw' then listeHF = HFList("tfw"); end
	if msg == 'firelands' then listeHF = HFList("firelands"); end
	if msg == 'ds' then listeHF = HFList("ds"); end	
	-- Spécials
	if msg == 'clean' then CleanTrackList() end
	if msg == 'check' then CheckBestRaid() end
	if msg == 'help' or msg == '' then
		print("AtA commands :");
		print("/ata {onyxia/archavon/malygos/sartha/naxx/ulduar/coliseum/icc}{10/25}");
		print("/ata {bwd,bot,tfw,firelands,ds}");
		-- print("Use '/ata check' to known the raid with less complete achievements.");
	end	
	-- Listing des HF
	if listeHF ~= 0 then
	SaveTrackList()
	CleanTrackList()
	AchievListRaid(listeHF)
	end
end
SlashCmdList["ATA"] = AtaCommand;

-- ////////////////
-- Processus passif
-- ////////////////

local function eventHandler(self, event, ...)
if event == "ZONE_CHANGED_NEW_AREA" then
	TextZone = GetZoneText();
	IdZone = GetCurrentMapAreaID();
		if TestingZone(IdZone) then -- La zone est gérer par l'addon
		IdCAT = CatHF(IdZone);
		SaveTrackList()
		CleanTrackList()
			if IdCAT == 0 then -- Pas de catégorie
			difficulty = GetInstanceDifficulty();
			listeHF = RaidHF(IdZone,difficulty);
			AchievListRaid(listeHF)
			else
			AchievListZone(IdCAT)
			end
		elseif not (TRACKED == nil) then -- Zone non gérer
			CleanTrackList()
			for i=1,#TRACKED do
			AddTrackedAchievement(TRACKED[i])
			end
			TRACKED = nil;
		end
	end
end

function AutoTrackerAchievement_OnLoad(self)
print("Achievement Tracker : OK");
self:RegisterEvent("ADDON_LOADED");
self:RegisterEvent("ZONE_CHANGED_NEW_AREA");
self:RegisterEvent("PLAYER_ENTERING_WORLD");
self:SetScript("OnEvent", eventHandler);
end

-- Fonction testant si la zone est gérée par l'addon
function TestingZone(IdZone)
	-- Battleground
	if IdZone == 461 then return true end -- "Arathi Basin"
	if IdZone == 401 then return true end -- "Alterac Valley"
	if IdZone == 482 then return true end -- "Eye of the Storm"
	if IdZone == 443 then return true end -- "Warsong Gulch"
	if IdZone == 512 then return true end -- "Strand of the Ancients"
	if IdZone == 501 then return true end -- "Wintergrasp"
	if IdZone == 540 then return true end -- "Isle of Conquest"
	if IdZone == 736 then return true end -- "Battle for Gilneas"
	if IdZone == 626 then return true end -- "Twin Peaks"
	if IdZone == 708 then return true end -- "Tol Barad"
	-- ARENA
	if IdZone == 14221 then return true end -- "Ruins of Lordaeron" -- ARENA
	if IdZone == 30301 then return true end -- "Blade's Edge Arena" -- ARENA
	if IdZone == 14221 then return true end -- "Dalaran Arena" -- ARENA
	if IdZone == 31121 then return true end -- "Nagrand Arena" -- ARENA
	if IdZone == 14221 then return true end -- "The Ring of Valor" -- ARENA
	-- Darkmoon Fair
	if IdZone == 823 then return true end
	-- Raids
		-- Wrath of the lich king
		if IdZone == 718 then return true end -- Onyxia
		if IdZone == 532 then return true end -- Archavon
		if IdZone == 527 then return true end -- Eye of Eternity
		if IdZone == 531 then return true end -- Sartharion
		if IdZone == 535 then return true end -- Naxxramas
		if IdZone == 529 then return true end -- Ulduar
		if IdZone == 543 then return true end -- Coliseum
		if IdZone == 604 then return true end -- ICC
		if IdZone == 609 then return true end -- Halion
		-- Cataclysm
		if IdZone == 754 then return true end -- BWD
		if IdZone == 758 then return true end -- Twilights
		if IdZone == 800 then return true end -- TDF/Firelands
		if IdZone == 773 then return true end -- tfw
		if IdZone == 824 then return true end -- DS
	-- Donjon
		-- Wrath of the lich king
		-- Cataclysm
	return false
end

-- Fonction qui renvoie la catégorie HF en fonction de la zone (pour les HF pvp et Sombrelune)
function CatHF(IdZone)
	-- Battleground
	if IdZone == 461 then return 14802 end -- "Arathi Basin"
	if IdZone == 401 then return 14801 end -- "Alterac Valley"
	if IdZone == 482 then return 14803 end -- "Eye of the Storm"
	if IdZone == 443 then return 14804 end -- "Warsong Gulch"
	if IdZone == 512 then return 14881 end -- "Strand of the Ancients"
	if IdZone == 501 then return 14901 end -- "Wintergrasp"
	if IdZone == 540 then return 15003 end -- "Isle of Conquest"
	if IdZone == 736 then return 15073 end -- "Battle for Gilneas"
	if IdZone == 626 then return 15074 end -- "Twin Peaks"
	if IdZone == 708 then return 15075 end -- "Tol Barad"
	-- ARENA
	if IdZone == 14221 then return 165 end -- "Ruins of Lordaeron" -- ARENA
	if IdZone == 30301 then return 165 end -- "Arène des tranchantes" -- ARENA
	if IdZone == 14221 then return 165 end -- "Egouts de Dalaran" -- ARENA
	if IdZone == 31121 then return 165 end -- "Arena of Nagrand" -- ARENA
	if IdZone == 14221 then return 165 end -- "Arena of Valor" -- ARENA
	-- Darkmoon Fair
	if IdZone == 823 then return 15101 end
	return 0
end

-- Fonction qui liste les HF selon la zone (raids et donjons)
function RaidHF(IdZone,difficulty)
	-- Wrath of the Lich-King
	diff = 10
	if difficulty == 2 or difficulty == 4 or difficulty == 25 then diff = 25 end

	if IdZone == 718 and diff == 10 then return HFList("onyxia10") end -- Onyxia10
	if IdZone == 718 and diff == 25 then return HFList("onyxia25") end -- Onyxia25
	if IdZone == 532 and diff == 10 then return HFList("archavon10") end -- Archavon10
	if IdZone == 532 and diff == 25 then return HFList("archavon25") end -- Archavon25
	if IdZone == 527 and diff == 10 then return HFList("malygos10") end -- Eye of Eternity10
	if IdZone == 527 and diff == 25 then return HFList("malygos25") end -- Eye of Eternity25
	if IdZone == 531 and diff == 10 then return HFList("sartha10") end -- Sartharion10
	if IdZone == 531 and diff == 25 then return HFList("sartha25") end -- Sartharion25
	if IdZone == 535 and diff == 10 then return HFList("naxx10") end -- Naxxramas10
	if IdZone == 535 and diff == 25 then return HFList("naxx25") end -- Naxxramas25
	if IdZone == 529 and diff == 10 then return HFList("ulduar10") end -- Ulduar10
	if IdZone == 529 and diff == 25 then return HFList("ulduar25") end -- Ulduar25
	if IdZone == 543 and diff == 10 then return HFList("coliseum10") end -- Coliseum10
	if IdZone == 543 and diff == 25 then return HFList("coliseum25") end -- Coliseum25
	if IdZone == 604 and diff == 10 then return HFList("icc10") end -- ICC10
	if IdZone == 604 and diff == 25 then return HFList("icc25") end -- ICC25
	
	-- Cataclysm
	if IdZone == 754 then return HFList("bwd") end -- BWD
	if IdZone == 758 then return HFList("bot") end -- Twilights
	if IdZone == 773 then return HFList("tfw") end -- tfw
	if IdZone == 800 then return HFList("firelands") end -- TDF/Firelands
	if IdZone == 824 then return HFList("ds") end -- DS
	
	-- Mists of Pandaria
	-- attente
end

function CleanTrackList() 
	local achievlisted = {GetTrackedAchievements()};	
	for i=1,#achievlisted do
		RemoveTrackedAchievement(achievlisted[i])
	end
end

function SaveTrackList()
if (not TRACKED) then
TRACKED = {GetTrackedAchievements()};
for i=1,#TRACKED do
end
else
end
end

-- Print the incomplete achievements in specific category and and them to the tracking list
function AchievListZone(IdCAT)
local n
local currentlytracked = 0
local incomplete = false
ACHIEVS_LIST = GetCategoryList();
for i,id in ipairs(ACHIEVS_LIST) do
n, parentID = GetCategoryInfo(id) -- récupère titre et idsup via Id de catégorie
if (IdCAT == id) then
		-- print("id = " .. id);
for j = 1, GetCategoryNumAchievements(id) do
			aid, aname, points, completed, month, day, year, description, flags, icon, rewardText, isGuildAch = GetAchievementInfo(id,j)
			if not completed then
				-- print (GetAchievementLink(aid));
				if currentlytracked < 10 then
				AddTrackedAchievement(aid);
				currentlytracked = currentlytracked +1
				end
				incomplete = true
			end
		end
	end
end
return incomplete
end

-- Print the incomplete achievements in specific raid and and them to the tracking list
function AchievListRaid(Raid)
	local currentlytracked = 0
	local incomplete = false
	for i=1,#Raid do
		aid, aname, points, completed, month, day, year, description, flags, icon, rewardText, isGuildAch = GetAchievementInfo(Raid[i])
		if not completed then
			-- print (GetAchievementLink(aid));
				if currentlytracked < 10 then
					AddTrackedAchievement(aid);
					currentlytracked = currentlytracked +1
					end
			incomplete = true
		end
	end
	return incomplete
end

-- Selectionne la liste des HFs de raids
function HFList(Raid)
	-- Wrath of the Lich King
	onyxia10={4404,4402}
	onyxia25={4407,4405}
	archavon10 = {4016}
	archavon25 = {4017}
	malygos10={1874,2148}
	malygos25={1875,2149}
	sartha10={2049,2050,2051,624,2047}
	sartha25={2052,2053,2054,1877,2048}
	naxx10={1997,1858,1856,2178,2176,1996,2182,2146,2184}
	naxx25={2140,1859,1857,2179,2177,2139,2183,2147,2185}
	ulduar10={2907,2909,3056,2905,2911,2925,2927,2930,2923,2919,
	3058,2937,2934,2931,2947,2945,2941,2940,2939,2951,2959,2953,
	2955,3006,3076,2961,3182,2963,2967,3176,2971,2977,2975,2973,
	2982,2980,3179,2989,3180,3138,3181,2996,3159,3015,3008,3012,
	3014,3003}
	ulduar25={2908,2910,3057,2906,2912,2926,2928,2929,2924,2921,
	3059,2938,2936,2932,2948,2946,2944,2943,2942,2952,2960,2954,
	2956,3007,3077,2962,3184,2965,2968,3183,2972,2978,2976,2974,
	2983,2981,3187,3237,3189,2995,3188,2997,3164,3016,3010,3013,
	3017,3002}
	coliseum10={3917,3797,3936,3996,3799,3800}
	coliseum25={3916,3813,3937,3997,3815,3816}
	icc25={4534,4535,4536,4537,4538,4577,4578,4582,4539,4579,4580,4581,4601}
	icc10={4610,4611,4612,4613,4614,4615,4616,4617,4618,4619,4620,4622,4621}
	
	-- Cataclysm
	bwd = {5306,5309,5307,5310,5308,4849,4842}
	bot = {4852,5312,5313,5311,4850}
	tfw = {5304,5305,4851}
	firelands = {5810,5813,5829,5821,5855,5799,5830,5802}
	ds = {6174,6180,6128,6105,6133,6107,6175,6084}
	
	-- Tableau
	TableauHF = {["onyxia10"] = onyxia10,
	["onyxia25"] = onyxia25,
	["archavon10"] = archavon10,
	["archavon25"] = archavon25,
	["malygos10"] = malygos10,
	["malygos25"] = malygos25,
	["sartha10"] = sartha10,
	["sartha25"] = sartha25,
	["naxx10"] = naxx10,
	["naxx25"] = naxx25,
	["ulduar10"] = ulduar10,
	["ulduar25"] = ulduar25,
	["coliseum10"] = coliseum10,
	["coliseum25"] = coliseum25,
	["icc10"] = icc10,
	["icc25"] = icc25,
	["bwd"] = bwd,
	["bot"] = bot,
	["tfw"] = tfw,
	["firelands"] = firelands,
	["ds"] = ds}

	-- Retour des données
	if Raid == 'table' then return TableauHF end
	return TableauHF[Raid]
end

-- Trouver le raid le plus rentable en HF
function CheckBestRaid()
	-- Tableau des HF
	Tableau = HFList('table');
	TableauNB = {};
	
	for i in pairs(Tableau) do
	TableauNB[i] = 0
		for j,v in pairs(Tableau[i]) do
		aid, aname, points, completed, month, day, year, description, flags, icon, rewardText, isGuildAch = GetAchievementInfo(v)
		if not completed then TableauNB[i] = TableauNB[i] + 1 end
		end
	end
	
	for i,v in pairs(TableauNB) do
		if v ~= 0 then print(i,v) end
	end
end
